package cz.upol.jj1.collections.lab07;

/**
 * Sequence of ints.
 */
public interface IntegerSequence {

    /**
     * Number of elements in the sequence
     * @return Number of elements
     */
     int size();

    /**
     * Checks if an element is in the sequence
     * @param element the element to be checked
     * @return Position of first occurence of the element, or -1 if not present
     */
    int contains(int element);


    /**
     * Returns new sequence with same elements in reversed order.
     * @return
     */
    IntegerSequence reversed();

    /**
     * Adds an element as the first element of this sequence.
     */
    void addFirst(int element);

    /**
     * Adds an element as the last element of this sequence.
     */
    void addLast(int element);

    /**
     * Gets the first element of this sequence.
     * @return the retrieved element.
     */
    int getFirst();

    /**
     * Gets the last element of this sequence.
     * @return the retrieved element.
     */
    int getLast();

    /**
     * Removes the first element of this sequence.
     * @return the removed element.
     */
    int removeFirst();

    /**
     * Removes the last element of this sequence.
     * @return the removed element.
     */
    int removeLast();

    /**
     * Removes first occurence of the element from the sequence.
     * @param element to be removed
     * @return the removed element
     */
    int remove(int element);


}
